Subject: Re: bug#53451: 28.0.91; Different behavior with native-compilation

From: Andrea Corallo <[email-masked]>
Date: Wed, 09 Feb 2022 17:16:53 +0000

Andrea Corallo <[email-masked]> writes:

> Frédéric Giquel via "Bug reports for GNU Emacs, the Swiss army knife of
> text editors" <[email-masked]> writes:
>
>> Hi Andrea,
>>
>> How can I help ?
>> Do you need further information ?
>>
>> Best Regards,
>> Frédéric Giquel
>
> Hi Frédéric,
>
> I've isolated `fish-get-end-indent' as the function causing the
> different behaviour.  I'll have a look into what is going on and report.
>
> Thanks
>
>   Andrea

Okay, this is an optimizer bug.

The compiler was convinced the following lambda returned 1 :/ and could
optimize accordingly...

(λ (x)
  (if (eq x 0)
      (error "foo")
    (1+ x)))

I've pushed the fix into emacs-28 as 69e82968d7 as I think this is
important to have in the release branch.  The commit include a testcase
as well.

Frédéric if you could compile emacs-28 and verify it works for you would
be nice (I guess you'll have to clean-up at least the miss-compiled
.eln)

Thanks

  Andrea